<?php
// +----------------------------------------------------------------------
// | 发送请求
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------
header('Content-type: text/html;charset=utf-8');

function json($code, $msg, $data=[]) {
    $return = [
        'code' => $code,
        'msg' => $msg,
        'data' => $data,
    ];

    echo json_encode($return, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
    exit;
}
function xmlToEncode($data){
    $xml = $attr = '';
    foreach ($data as $key=>$value) {
        if(is_numeric($key)){
            $attr = "id='{$key}'";
            $key = "item";
        }
        $xml .= "<{$key} {$attr}>";
        $xml .= is_array($value) ? xmlToEncode($value) : $value;
        $xml .= "</{$key}>";
    }
    return $xml;
}

function convertEncoding($string){
    //根据系统进行配置
    $encode = stristr(PHP_OS, 'WIN') ? 'GBK' : 'UTF-8';
    $string = iconv('UTF-8', $encode, $string);
    return $string;
}
if (empty($_POST['url'])) return json('01', '缺少请求地址');
if (empty($_POST['name'])) return json('01', '缺少记录名');

$data = [];
if (!empty($_POST['field'])) {
    foreach ($_POST['field'] as $k => $v) {
        $data[$v] = $_POST['value'][$k];
    }
}
$field_data = $data;

$headers = [];
if ($_POST['type'] == 2) {
    $data = json_encode($data);
    $headers = [
        'Content-Type: application/json; charset=utf-8',
        'Content-Length: ' . strlen($data)
    ];
} else if ($_POST['type'] == 3) {
    $data = '<xml>'.xmlToEncode($data).'</xml>';
    $headers = [
        'Content-Type:text/xml; charset=utf-8'
    ];
} else if ($_POST['type'] == 4) {
    $data = json_encode($data);
    $headers = [
        'Content-Type: text/plain'
    ];
}

$curl = curl_init();  
curl_setopt($curl, CURLOPT_URL, $_POST['url']);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);

//设置为post请求类型
if (strtolower($_POST['method']) == 'post') {
    curl_setopt($curl, CURLOPT_POST, 1);
}
//设置具体的post数据
curl_setopt($curl, CURLOPT_POSTFIELDS, $data);  

if (!empty($headers)){
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
}
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);        
$response = curl_exec($curl);
curl_close($curl);

if (!$response) return json('01', '请求失败');
// 防止低版本的PHP接口json不带字符串
if (substr($response , 0 , 1) == '{') {
    $response = json_encode(json_decode($response, true), JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
}

// 看看记录是否存在
$dir = dirname(__FILE__).DIRECTORY_SEPARATOR;
$field_dir = $dir.'field'.DIRECTORY_SEPARATOR.md5($_POST['url']).DIRECTORY_SEPARATOR;
$field_path = convertEncoding($field_dir.$_POST['name'].'.json');
$result_dir = $dir.'result'.DIRECTORY_SEPARATOR.md5($_POST['url']).DIRECTORY_SEPARATOR;
$result_path = convertEncoding($result_dir.$_POST['name'].'.json');

if (!file_exists($field_dir)) mkdir(convertEncoding($field_dir),0777,true);
if (!file_exists($result_dir)) mkdir(convertEncoding($result_dir),0777,true);
file_put_contents($field_path, json_encode($field_data, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
file_put_contents($result_path, $response);

return json('00', '请求成功', $response);